"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var ipfsAPI = require("ipfs-api");
var ipld = require("ipld-dag-cbor");
var jiff = require("jiff");
import * as _ from "lodash";
var TransmuteIpfsSingleton = (function () {
    function TransmuteIpfsSingleton() {
        var _this = this;
        this.isObjectStore = true; //used to tell if objects are stored on ipfs or in ethereum... pretty hacky...
        this.hashesToPatches = function (hashes) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var marshalledPatches, promises;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(hashes.map(function (hash) {
                            return _this.readBuffer(hash);
                        }))];
                    case 1:
                        marshalledPatches = _a.sent();
                        return [4 /*yield*/, marshalledPatches.map(function (marshalled) {
                                return new Promise(function (resolve, reject) {
                                    ipld.util.deserialize(new Buffer(marshalled), function (err, data) {
                                        if (err) {
                                            reject(err);
                                        }
                                        resolve(data);
                                    });
                                });
                            })];
                    case 2:
                        promises = _a.sent();
                        return [2 /*return*/, Promise.all(promises)];
                }
            });
        }); };
        this.applyPatches = function (obj, patches) {
            var patched = _.cloneDeep(obj);
            patches.forEach(function (patch) {
                patched = jiff.patchInPlace(patch, patched);
            });
            return patched;
        };
        this.applyIPLDHashes = function (obj, hashes) { return __awaiter(_this, void 0, void 0, function () {
            var patches;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.hashesToPatches(hashes)];
                    case 1:
                        patches = _a.sent();
                        return [2 /*return*/, this.applyPatches(obj, patches)];
                }
            });
        }); };
        this.patch = function (target, patch) {
            return jiff.patchInPlace(patch, target);
        };
        this.diff = function (start, end) {
            return jiff.diff(start, end);
        };
    }
    TransmuteIpfsSingleton.prototype.init = function (config) {
        if (config === void 0) { config = {
            host: "localhost",
            port: "5001",
            options: {
                protocol: "http"
            }
        }; }
        this.config = config;
        this.ipfs = ipfsAPI(this.config.host, this.config.port, this.config.options);
        return this;
    };
    TransmuteIpfsSingleton.prototype.addFromFs = function (folderPath, options) {
        var _this = this;
        if (options === void 0) { options = {
            recursive: true,
            ignore: ["node_modules/**"]
        }; }
        return new Promise(function (resolve, reject) {
            _this.ipfs.util.addFromFs(folderPath, options, function (err, result) {
                if (err) {
                    reject(err);
                }
                resolve(result);
            });
        });
    };
    TransmuteIpfsSingleton.prototype.addFromURL = function (url) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ipfs.util.addFromURL(url, function (err, result) {
                if (err) {
                    reject(err);
                }
                resolve(result);
            });
        });
    };
    TransmuteIpfsSingleton.prototype.writeBuffer = function (buffer) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ipfs.add(buffer, function (err, res) {
                if (err || !res) {
                    reject(err);
                }
                resolve(res[0].path);
            });
        });
    };
    TransmuteIpfsSingleton.prototype.writeObject = function (obj) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            ipld.util.serialize(obj, function (err, serialized) {
                if (err) {
                    reject(err);
                }
                resolve(_this.writeBuffer(serialized));
            });
        });
    };
    TransmuteIpfsSingleton.prototype.readBuffer = function (hash) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ipfs.cat(hash, function (err, stream) {
                if (err) {
                    reject(err);
                }
                var data = new Buffer("");
                stream.on("data", function (chunk) {
                    data = Buffer.concat([data, chunk]);
                });
                stream.on("end", function () {
                    resolve(data);
                });
            });
        });
    };
    TransmuteIpfsSingleton.prototype.readObject = function (path) {
        if (path.indexOf("ipfs/") !== -1) {
            path = path.split("ipfs/")[1];
        }
        return this.readBuffer(path).then(function (serialized) {
            return new Promise(function (resolve, reject) {
                ipld.util.deserialize(serialized, function (err, data) {
                    if (err) {
                        reject(err);
                    }
                    resolve(data);
                });
            });
        });
    };
    // See https://github.com/cujojs/jiff
    TransmuteIpfsSingleton.prototype.statesToPatches = function (states) {
        return new Promise(function (resolve, reject) {
            var patches = [];
            for (var i = 0; i <= states.length - 2; i++) {
                patches.push(jiff.diff(states[i], states[i + 1]));
            }
            resolve(patches);
        });
    };
    TransmuteIpfsSingleton.prototype.patchesToHashes = function (patches) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var marshalledPatches, buffers, promises;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        marshalledPatches = patches.map(function (patch) {
                            // return ipld.marshal(patch)
                            return new Promise(function (resolve, reject) {
                                ipld.util.serialize(patch, function (err, serialized) {
                                    if (err) {
                                        reject(err);
                                    }
                                    resolve(serialized);
                                });
                            });
                        });
                        return [4 /*yield*/, Promise.all(marshalledPatches)];
                    case 1:
                        buffers = _a.sent();
                        promises = buffers.map(function (mp) {
                            return _this.writeBuffer(mp);
                        });
                        resolve(Promise.all(promises));
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return TransmuteIpfsSingleton;
}());
export { TransmuteIpfsSingleton };
export var TransmuteIpfs = new TransmuteIpfsSingleton();
//# sourceMappingURL=TransmuteIpfs.js.map